# Used by 'hunt and track' method to calculate a 'predominance' diagram based on the 'stability' criterion
PRINT
   -reset false
   -user_print t
PHASES
Fix_H+
   H+ = H+
   log_k 0.0
SELECTED_OUTPUT 1
   -high_precision t
   -reset false
USER_PUNCH 1
-headings 
-start
1 small = 1e-12
10 ns = 0
20 h2o = TOT("water")
30 type$ = "Stability"
40 main$ = "<mainspecies>"
50 REM maximum number of surfaces=100
60 DIM s$(100)
70 IF(STEP_NO = 0) THEN 850 ELSE 120
80 REM Print a list of minerals to the output file for pasting in
90 REM if required
100 REM This will require any PRINT -reset false statement to be
110 REM commented out or reset to true
120 REM totm = SYS("phases", nm, nm$, tm$, mm)
130 REM FOR i = 1 TO nm
140 REM   k = INSTR(nm$(i), "(g)")+INSTR(nm$(i), "Fix")+INSTR(nm$(i), "FIX")+INSTR(nm$(i), "fix")
150 REM   IF(k > 0) THEN 170
160 REM   PRINT " ", CHR$(35)+PAD(nm$(i), 30), "0", "0"
170 REM NEXT i
180 nout1 = 0
190 REM Find top 3 species omitting surface species
200 totel = SYS(main$, n, n$, t$, moles)
210 REM Filter out surfaces and gases
220 FOR i = 1 TO n
230    IF(moles(i) <= small) THEN 310
240    IF(t$(i) = "surf") THEN 300
250    IF(INSTR(n$(i), "(g)") > 0) THEN 300
260    IF(t$(i) = "equi" AND INSTR(n$(i), "(g)") = 0) THEN nt$ = n$(i)+"(s)"
270    PUNCH n$(i), moles(i)/h2o
280    nout1 = nout1+1
290    IF(nout1 >= 3) THEN 310
300 NEXT i
310 REM Now add any SURFACES...
320 totsurf = SYS("surf", ne, ne$, te$, me)
330 FOR i = 1 TO ne
340    IF(te$(i) <> "surf") THEN 480
350    PRINT i, PAD(ne$(i),20), te$(i), me(i)/h2o
360    k = INSTR(ne$(i), "_")
370    IF(k > 1) THEN ne$(i) = MID$(ne$(i), 1, k-1)
380    IF(ns <= 0) THEN 420
390    FOR ii = 1 TO ns
400       IF ne$(i) = s$(ii) THEN 480
410    NEXT ii
420    ns = ns+1
430    s$(ns) = ne$(i)
440    s = SURF(main$, s$(ns))
450    IF(s < 1e-14) THEN 480
460    PUNCH s$(ns)+"-"+TRIM(main$), s/h2o
470    nout1 = nout1+1
480 NEXT i
490 REM Now MINERAL constraints...
500 IF(type$ <> "Stability") THEN 570
510 FOR i = 1 TO n
520    IF(INSTR(n$(i), "(g)") > 0) THEN 560
530    IF(t$(i) = "equi" AND moles(i) > 0) THEN 540 ELSE 560
540    PUNCH n$(i), moles(i)/h2o
550    nout2 = nout2+1
560 NEXT i
570 nout3 = 0
580 REM Next any OTHER constraints...
590 IF(SI("H2(g)") > 0) THEN 600 ELSE 620
600 PUNCH "H2(g) > 1 atm", 10^SI("H2(g)")
610 nout3 = nout3+1
620 IF(SI("O2(g)") > -0.677) THEN 630 ELSE 650
630 PUNCH "O2(g) > 0.21 atm", 10^SI("O2(g)")
640 nout3 = nout3+1
650 IF(SI("CH4(g)") > 0) THEN 660 ELSE 710
660 PUNCH "CH4(g) > 1 atm", 10^SI("CH4(g)")
670 nout3 = nout3+1
680 REM Add any 'carry' variables here...
690 REM ... these are in 'carry.inc'
700 REM
710 GOSUB 1000
720 nout4 = npunch
740 REM
750 REM Now add 'SYSTEM' variables ...
760 REM Always include these 5...
770 po2 = SI("O2(g)")
780 ph2 = SI("H2(g)")
790 ph = -LA("H+")
800 pe = -LA("e-")
810 PUNCH "pH", ph, "pe", pe, "PO2", po2, "PH2", ph2, "temp", TC
820 nout5 = 5
830 REM Finally send the counters...
840 PUNCH nout1, nout2, nout3, nout4, nout5
850 END

include 'carry.inc'

